/* This program will input midi data on channel 1
 *  and set joystick- 8 bits to play a single voice on the
 *  Atari.  A NOTEON will sound a note.  if a noteoff command,
 *  will turn off the specified note only if it was the last 
 *  note turned on.
 */

// Atari PORTA(54016) mapped to pins on arduino
int porta0 = 4;
int porta1 = 5;
int porta2 = 6;
int porta3 = 7;
int porta4 = 8;
int porta5 = 9;
int porta6 = 10;
int porta7 = 11;

int trigger = 3;
byte lastNoteOn = 0;
byte NOTEON = 144;
byte NOTEOFF = 128;

byte midiCommand = 0;
byte midiNoteNumber = 0;
byte midiNoteVol = 0;
byte zero = 0;

void setPorta(byte byteToMap){
  // sets digital pins to transfer data to Atari joystick ports(PORTA)
  if (byteToMap & B00000001){digitalWrite(porta0,HIGH);}
    else {digitalWrite(porta0,LOW);}
  if (byteToMap & B00000010){digitalWrite(porta1,HIGH);}
    else {digitalWrite(porta1,LOW);}
  if (byteToMap & B00000100){digitalWrite(porta2,HIGH);}
    else {digitalWrite(porta2,LOW);}
  if (byteToMap & B00001000){digitalWrite(porta3,HIGH);}
    else {digitalWrite(porta3,LOW);}
  if (byteToMap & B00010000){digitalWrite(porta4,HIGH);}
    else {digitalWrite(porta4,LOW);}
  if (byteToMap & B00100000){digitalWrite(porta5,HIGH);}
    else {digitalWrite(porta5,LOW);}
  if (byteToMap & B01000000){digitalWrite(porta6,HIGH);}
    else {digitalWrite(porta6,LOW);}
  if (byteToMap & B10000000){digitalWrite(porta7,HIGH);}
    else {digitalWrite(porta7,LOW);}
}

void setup() {
  pinMode(porta0,OUTPUT);
  pinMode(porta1,OUTPUT);
  pinMode(porta2,OUTPUT);
  pinMode(porta3,OUTPUT);
  pinMode(porta4,OUTPUT);
  pinMode(porta5,OUTPUT);
  pinMode(porta6,OUTPUT);
  pinMode(porta7,OUTPUT);
  pinMode(trigger,OUTPUT);
  Serial.begin(31250);
  setPorta(zero);
  digitalWrite(trigger,LOW);
}

void loop() {
  while(Serial.available()<1){}//wait for data
  midiCommand = Serial.read();
  
  if ((midiCommand == NOTEON) || (midiCommand == NOTEOFF)){   // Note On - Channel 1
   while(Serial.available()<1){}
   midiNoteNumber = Serial.read();
   while(Serial.available()<1){}
   midiNoteVol = Serial.read();
  }
   // got the data now send it to atari

   if((midiCommand == NOTEON) && (midiNoteVol > 0)){
    setPorta(NOTEON);
    delay(30);
    setPorta(midiNoteNumber);
    digitalWrite(trigger,HIGH);
    lastNoteOn = midiNoteNumber;
    delay(30);
    // setPorta(zero);
    digitalWrite(trigger,LOW);
   }

   if((midiNoteNumber == lastNoteOn)&&(((midiCommand == NOTEON) && (midiNoteVol == 0))||(midiCommand == NOTEOFF))){
    setPorta(NOTEOFF);
    delay(30);
    setPorta(zero);
   }

  }





