/* Use an Atari 8bit computer as midi drum synth.
 *  Modified Synth Drum program from Antic 2/85 produced drum sounds.
 *  Replaces Atari Keyboard with MIDI Keyboard or sequencer
 *  Arduino with MIDI shield provided input to joystick port
 *             through opto couplers.
 *  MIDI Keyboard output to Arduino.
 *  
 *  Reads keyboard MIDI code and converts to 4 bit code to joystick.
 *  Trigger bit used for control and timing.
*/
int J1 = 4; // Pin 4 to Joystick pin 1
int J2 = 5; // Pin 5 to Joystick pin 2
int J3 = 6; // Pin 6 to joystick pin 3
int J4 = 7; // pin 7 to Joystick pin 4
int trigger = 3; // pin 3 to Joystick trigger pin
byte midiData = 0; // Used to examine MIDI data stream
byte midiNoteNumber = 0; //send by key press on MIDI Keyboard
byte velocity = 0; // holds velocity data that is not used

void setup() {
  pinMode(J1,OUTPUT);
  pinMode(J2,OUTPUT);
  pinMode(J3,OUTPUT);
  pinMode(J4,OUTPUT);
  pinMode(trigger,OUTPUT);

  Serial.begin(31250); // MIDI standard
}

void loop() {
  while(Serial.available()<1){}//wait for data
  midiData = Serial.read();
  if (midiData == 153){   // NoteOn + Channel 10 
   while(Serial.available()<2){}
   midiNoteNumber = Serial.read();
   velocity = Serial.read();
   if (velocity != 0){
    switch(midiNoteNumber){  // output 4 bit number for MIDI NOTE
      case 36: //Base drum = 1 // mapped to drum sound
      digitalWrite(J1,HIGH);
      digitalWrite(trigger,HIGH);
      break;
      case 38: //Snare drum = 2
      digitalWrite(J2,HIGH);
      digitalWrite(trigger,HIGH);
      break;
      case 40: // Drum-Synth = 3
      digitalWrite(J1,HIGH);
      digitalWrite(J2,HIGH);
      digitalWrite(trigger,HIGH);
      break;
      case 39: // Hand Clap = 4
      digitalWrite(J3,HIGH);
      digitalWrite(trigger,HIGH);
      break;
      case 41: // Tom Low = 5
      digitalWrite(J1,HIGH);
      digitalWrite(J3,HIGH);
      digitalWrite(trigger,HIGH);
      break;
      case 43: // Tom 2 = 6
      digitalWrite(J2,HIGH);
      digitalWrite(J3,HIGH);
      digitalWrite(trigger,HIGH);
      break;
      case 45: // Tom 3 = 7
      digitalWrite(J1,HIGH);
      digitalWrite(J2,HIGH);
      digitalWrite(J3,HIGH);
      digitalWrite(trigger,HIGH);
      break;
      case 47: // Tom 4 = 8
      digitalWrite(J4,HIGH);
      digitalWrite(trigger,HIGH);
      break;
      case 48: // Tom 5 = 9
      digitalWrite(J1,HIGH);
      digitalWrite(J4,HIGH);
      digitalWrite(trigger,HIGH);
      break;
      case 42: // High hat closed = 10
      digitalWrite(J2,HIGH);
      digitalWrite(J4,HIGH);
      digitalWrite(trigger,HIGH);
      break;
      case 46: // High hat opened = 11
      digitalWrite(J1,HIGH);
      digitalWrite(J2,HIGH);
      digitalWrite(J4,HIGH);
      digitalWrite(trigger,HIGH);
      break;
      case 49: // crash symbal = 12
      digitalWrite(J3,HIGH);
      digitalWrite(J4,HIGH);
      digitalWrite(trigger,HIGH);
      break;
    }
     }
  delay(50);// give atari a chance to read joystick
            // this set by trial and error
  digitalWrite(trigger,LOW); // reset for next drum hit
  digitalWrite(J1,LOW);
  digitalWrite(J2,LOW);
  digitalWrite(J3,LOW);
  digitalWrite(J4,LOW);
  }
}
